/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package FinancialTransaction;

import TransactionalIO.Utilities.Range;
import TransactionalIO.interfaces.IOOperations;
import TransactionalIO.core.MyDefaults;
import TransactionalIO.core.ExtendedTransaction;
import TransactionalIO.core.TransactionLocalFileAttributes;
import TransactionalIO.core.TransactionalFile;
import TransactionalIO.core.Wrapper;
import TransactionalIO.core.WriteOperations;
import TransactionalIO.exceptions.GracefulException;
import dstm2.SpecialTransactionalFile;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Iterator;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import dstm2.Thread;
import dstm2.atomic;
import dstm2.AtomicArray;
import dstm2.Defaults;
import dstm2.factory.Factory;


import java.io.RandomAccessFile;

import java.util.Vector;

import java.util.concurrent.Callable;

/**
 *
 * @author navid
 */
public class FinancialTransaction implements Runnable {


    private Thread thread;
    String st = new String();
    static boolean inevitable = Defaults.INEVITABLE;
    int size;
    long threadoffset;
    static String basedir;



    ///////////////////financialbenchmark data structure//////////////////
    static String[] stocks;
    static HashMap financialbm1;
    static HashMap financialbm2;
    byte[] financedata = new byte[11];
    char[] balance = new char[20];	
    byte[] financedata2 = new byte[41];
    static TransactionalFile accountbalance=null; 
    static SpecialTransactionalFile inevitableaccountbalance=null; 
    static AtomicArray<FTrHolder> financialTransactionKeeper;
    private static Factory<FinancialTransactionDS> factory = Thread.makeFactory(FinancialTransactionDS.class);
    private static Factory<RootHolder> factory2 = Thread.makeFactory(RootHolder.class);
    private static Factory<FTrHolder> factory3 = Thread.makeFactory(FTrHolder.class);
    //////////////////////////////////////////////////////////////////////



    public FinancialTransaction() {
        thread = new Thread(this);
   }

    public static void initFinance(String bdir)
    {
	basedir = bdir;
	try{
		if (inevitable)	
			inevitableaccountbalance= new SpecialTransactionalFile(basedir+"accountbalance.txt","rw");
		else 
			accountbalance= new TransactionalFile(basedir+"accountbalance.txt","rw");
	}

	catch(IOException ex){
		ex.printStackTrace();
	}
	
	preparenamelist();	

	RootHolder ck = factory2.create();
	ck.setFinancialTransactionKeeper(new AtomicArray<FTrHolder>(FTrHolder.class, 20));

	financialTransactionKeeper = ck.getFinancialTransactionKeeper();
	for (int i=0; i<20; i++){
		FTrHolder f1 = factory3.create();
		f1.setCounter(1);
		f1.setFinancialTransactionKeeper(new AtomicArray<FinancialTransactionDS>(FinancialTransactionDS.class, 5));
		for (int j=0; j<5; j++) {
			FinancialTransactionDS ftk = factory.create();
			ftk.setBuyer("");
			ftk.setSeller("");
			ftk.setSoldShare(0);
	        	AtomicArray<FinancialTransactionDS> tmp = f1.getFinancialTransactionKeeper();
			tmp.set(j, ftk);
		}
	
		financialTransactionKeeper.set(i, f1);
	}
}
   


    public void start() {
        thread.start();
    }

    public void join() {
        try {
            thread.join();
        } catch (InterruptedException ex) {
            Logger.getLogger(FinancialTransaction.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void run() {

        financialBenchmark();
    }


    public void financialBenchmark() {
      try {
	    RandomAccessFile f1;
	    f1 = new RandomAccessFile(basedir+"financialtransaction.text", "rw");
            String data = new String();
            int counter = 0;
            long toseek;
            long threadoffset = 360611*2;
            toseek = (Integer.valueOf(Thread.currentThread().getName().substring(7))) * threadoffset; 
            f1.seek(toseek);
            if (toseek != 0) {
                //////////////// skipt the first line since its been read already            
		data = f1.readLine();
		if (data == null)
			return;
            }

            while (f1.getFilePointer() < toseek + threadoffset) {

                counter = 0;
		data = f1.readLine();

                if (data == null) 
	            break;

                while (data.charAt(counter) != ' ') {
                    counter++;
                }

                final String oldowner = data.substring(0, counter);
		counter++;
	        int counter2 = counter;
                while (data.charAt(counter) != ' ') {
                    counter++;
                }


                final int exchange = Integer.parseInt(data.substring(counter2, counter ));

		counter++;
                counter2 = counter;

                while (data.charAt(counter) != ' ') {
                    counter++;
                }

                final String newowner = data.substring(counter2, counter);

		counter++;
                counter2 = counter;
                for (int j=counter; j<data.length(); j++) {
                    counter++;
                }

                final String company = data.substring(counter2, counter);
                boolean result = Thread.doIt(new Callable<Boolean>() {
                    public Boolean call() {
                        financialexecute(oldowner, exchange, newowner, company);
                        return true;
                    }
                });
            }


        } catch (IOException ex) {
           Logger.getLogger(FinancialTransaction.class.getName()).log(Level.SEVERE, null, ex);
        }

    }



    private long financialcomputeandupdate(boolean type, String oldowner, int stocktrade, String newowner, String nameofstock) {
        try {

            int counter = 0;
	    if (inevitable)
	          inevitableaccountbalance.read(financedata);
            else 
	          accountbalance.read(financedata);
            int adad;
            for (adad = 0; adad < stocks.length; adad++) {
                if (stocks[adad].equalsIgnoreCase(nameofstock)) {
                    break;
                }
            }
	    if (inevitable){
	            inevitableaccountbalance.skipBytes(adad * 41);
        	    inevitableaccountbalance.read(financedata2);
	    }
	    else{
                    accountbalance.skipBytes(adad * 41);
	            accountbalance.read(financedata2);
	    }

            int i = 0;
            while ((char) financedata2[i] != ':') {
                i++;
            }

            i++;
            long offsettowrite;


	    if (inevitable)
            	 offsettowrite = inevitableaccountbalance.getFilePointer();
            else
            	 offsettowrite = accountbalance.getFilePointer();
		 
            offsettowrite += i - 40;

            do {
                i++;
                balance[counter] = (char) financedata2[i];
                counter++;
            } while (Character.isDigit((char) financedata2[i]) || (char) financedata2[i] == '-');

            int oldbalance = Integer.parseInt(String.valueOf(balance, 0, counter - 1));
            int newnumber;
            if (type) {
                newnumber = oldbalance - stocktrade;
            } else {
                newnumber = oldbalance + stocktrade;

            }
            st = String.valueOf(newnumber);
            if (st.length() < counter - 1) {

                for (int j = 0; j < counter - String.valueOf(newnumber).length(); j++) {
                    st += new String(" ");
                }
            }

            return offsettowrite;


        } catch (IOException ex) {
            Logger.getLogger(FinancialTransaction.class.getName()).log(Level.SEVERE, null, ex);
            return -1;
        }

    }
   

private static void preparenamelist() {
        try {
            byte[] data = new byte[1];
            char[] name = new char[20];
            RandomAccessFile file = new RandomAccessFile(basedir+"namelist.text", "rw");
            RandomAccessFile file3 = new RandomAccessFile(basedir+"accountbalance.text", "rw");

            stocks = new String[20];
            stocks[0] = "Yahoo";
            stocks[1] = "Google";
            stocks[2] = "Microsoft";
            stocks[3] = "Broadcom";
            stocks[4] = "Sun";
            stocks[5] = "Qualcom";
            stocks[6] = "Intel";
            stocks[7] = "WaMU";
            stocks[8] = "BoA";
            stocks[9] = "IMU";
            stocks[10] = "BMW";
            stocks[11] = "Nokia";
            stocks[12] = "Motorolla";
            stocks[13] = "Samsung";
            stocks[14] = "TMobile";
            stocks[15] = "ATT";
            stocks[16] = "PRops";
            stocks[17] = "Asia";
            stocks[18] = "LOLa";
            stocks[19] = "Brita";

            boolean flag = false;
            boolean done = false;
            int wordcounter = 0;
            int counter = 0;
            financialbm1 = new HashMap();
            financialbm2 = new HashMap();

            while (true) {
                if (flag) {
                    break;
                }
                if (done) {
                    financialbm1.put(Integer.valueOf(wordcounter), String.copyValueOf(name, 0, counter));
                    financialbm2.put(String.copyValueOf(name, 0, counter), Integer.valueOf(wordcounter));
                    wordcounter++;
                    done = false;
                }
                counter = 0;
                data[0] = 'a';
                while (data[0] != '\n') {
                    int res;
                    res = file.read(data);
                    if (res == -1) {
                        flag = true;
                        break;
                    }
                    if (!(Character.isLetter((char) data[0]))) {
                        continue;
                    }
                    name[counter] = (char) data[0];
                    done = true;
                    counter++;
                }
            }



///preparing the accountbalance file/////////
/*
            for (int i = 0; i < 50; i++) {
                String towrite = (String) financialbm1.get(Integer.valueOf(i));
                String tmpst = (String) financialbm2.get(Integer.valueOf(i));
                System.out.println("Ss " + tmpst);
                int tmp = tmpst.length();
                while (tmp < 10) {
                    towrite += new String(" ");
                    tmp++;
                }
                towrite += "\n";
                for (int j = 0; j < stocks.length; j++) {
                    tmpst = stocks[j] + " Stock Balance: " + ((int) (Math.random() * 100 + 100));
                    towrite += stocks[j] + " Stock Balance: " + ((int) (Math.random() * 100 + 100));
                    tmp = tmpst.length();
                    while (tmp < 40) {
                        towrite += new String(" ");
                        tmp++;
                    }
                    towrite += "\n";
                }

                file3.write(towrite.getBytes());
                while (file3.getFilePointer() < (i + 1) * MyDefaults.FILEFRAGMENTSIZE) {
                    file3.write(new String(" ").getBytes());
                }
            }

////////////////////////////////////////////
*/
            file.close();
            file3.close();
        } catch (IOException ex) {
            Logger.getLogger(FinancialTransaction.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

  
       
    protected void financialexecute(String oldowner, int stocktrade, String newowner, String nameofstock) {
       try {
              Integer offset1 = (Integer) financialbm2.get(oldowner);
              Integer offset2 = (Integer) financialbm2.get(newowner);

	      if (inevitable)	
	              inevitableaccountbalance.seek(offset1 * MyDefaults.FILEFRAGMENTSIZE);
	      else
	              accountbalance.seek(offset1 * MyDefaults.FILEFRAGMENTSIZE);

              long offsettowrite = financialcomputeandupdate(true, oldowner, stocktrade, newowner, nameofstock);
	      if (inevitable){
	              inevitableaccountbalance.seek(offsettowrite);
        	      inevitableaccountbalance.write(st.getBytes());
	      }
	      else {
	              accountbalance.seek(offsettowrite);
        	      accountbalance.write(st.getBytes());
	      }


	      if (inevitable)
	              inevitableaccountbalance.seek(offset2 * MyDefaults.FILEFRAGMENTSIZE);
	      else 
	              accountbalance.seek(offset2 * MyDefaults.FILEFRAGMENTSIZE);

              offsettowrite = financialcomputeandupdate(false, oldowner, stocktrade, newowner, nameofstock);
		
	    
	      if (inevitable){
        	      inevitableaccountbalance.seek(offsettowrite);
	              inevitableaccountbalance.write(st.getBytes());
	      }
	      else {
        	      accountbalance.seek(offsettowrite);
	              accountbalance.write(st.getBytes());
	      }

            int i;
            for (i = 0; i < stocks.length; i++) {
                if (stocks[i].equalsIgnoreCase(nameofstock)) {
                    break;
                }
            }
            switch (financialTransactionKeeper.get(i).getCounter()) {
                case 1:
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(0).setSeller(oldowner);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(0).setSoldShare(stocktrade);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(0).setBuyer(newowner);
                    financialTransactionKeeper.get(i).setCounter(2);
                    break;
                case 2:
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(1).setSeller(oldowner);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(1).setSoldShare(stocktrade);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(1).setBuyer(newowner);
                    financialTransactionKeeper.get(i).setCounter(3);
                    break;
                case 3:
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(2).setSeller(oldowner);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(2).setSoldShare(stocktrade);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(2).setBuyer(newowner);
                    financialTransactionKeeper.get(i).setCounter(4);
                    break;
                case 4:
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(3).setSeller(oldowner);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(3).setSoldShare(stocktrade);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(3).setBuyer(newowner);
                    financialTransactionKeeper.get(i).setCounter(5);
                    break;
                case 5:
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(4).setSeller(oldowner);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(4).setSoldShare(stocktrade);
                    financialTransactionKeeper.get(i).getFinancialTransactionKeeper().get(4).setBuyer(newowner);
                    financialTransactionKeeper.get(i).setCounter(1);
                    break;
            }

        } catch (IOException ex) {
            Logger.getLogger(FinancialTransaction.class.getName()).log(Level.SEVERE, null, ex);
        }
    }


    @atomic
    public interface FinancialTransactionDS {
	String getSeller();
	void setSeller(String value);
	int getSoldShare();
	void setSoldShare(int value);
	String getBuyer();
        void setBuyer(String value);

    }	

    @atomic 
    public interface FTrHolder {
	AtomicArray<FinancialTransactionDS> getFinancialTransactionKeeper();
	void setFinancialTransactionKeeper(AtomicArray<FinancialTransactionDS> arr);
	int getCounter();
	void setCounter(int value);
    }	

    @atomic 
    public interface RootHolder {
	AtomicArray<FTrHolder> getFinancialTransactionKeeper();	
	void setFinancialTransactionKeeper(AtomicArray<FTrHolder> arr);

    }

    @atomic
    public interface CountKeeper{
        int getOccurence();
        void setOccurence(int value);;
    }
}

