/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package FinancialTransaction;

import dstm2.Defaults;
import dstm2.Thread;
import dstm2.*;

/**
 *
 * @author navid
 */
public class Main {
    static int thradnum;

    public static void main(String args[]){
    	int numThreads = Defaults.THREADS;
    	String managerClassName = Defaults.MANAGER;
    	Class managerClass = null;
    	String adapterClassName = Defaults.ADAPTER;
	String basedir = "/scratch/TransactionalIO/FinancialTransactionFilesv0/";
    
    	// discard statistics from previous runs
    	Thread.clear();
    
    	// Parse and check the args
    	int argc = 0;
    	try {
        	while (argc < args.length) {
    		    	String option = args[argc++];
        		if (option.equals("-m")){
          			managerClassName = args[argc];
	        	}
        		else if (option.equals("-inevitable")){
	        	         Defaults.INEVITABLE = Boolean.parseBoolean(args[argc]);
	        	}
		        else if (option.equals("-t"))
          			numThreads = Integer.parseInt(args[argc]);
	        	else if (option.equals("-a"))
        	  		adapterClassName = args[argc];
	        	else if (option.equals("-basedir"))	
				basedir = args[argc];
	        	else
        	  		reportUsageErrorAndDie();
	        	argc++;
	        }
        } catch (NumberFormatException e) {
      		System.out.println("Expected a number: " + args[argc]);
      		System.exit(0);
        } catch (Exception e) {
      		reportUsageErrorAndDie();
        }
        thradnum = numThreads;
        // Initialize contention manager.
        try {
        	System.out.println("Inevitable: " + Defaults.INEVITABLE);
        	managerClass = Class.forName(managerClassName);
      		Thread.setContentionManagerClass(managerClass);
    	} catch (ClassNotFoundException ex) {
      		System.out.println("Expected a number: ");
      		reportUsageErrorAndDie();
    	}	
    
   	 // Initialize adapter class
    	Thread.setAdapterClass(adapterClassName);
    
    
    	// Set up the benchmark
    	long startTime = 0;
        FinancialTransaction.initFinance(basedir);
    
	FinancialTransaction[] thread = new FinancialTransaction[numThreads];
    	System.out.println("Adapter: " + adapterClassName);
    	System.out.println("Contention manager: " + managerClassName);
    	System.out.println("Threads: " + numThreads);
    	try {
        	for (int i = 0; i < numThreads; i++){
                thread[i] = new FinancialTransaction();
        }
      
        startTime = System.currentTimeMillis();
        for (int i = 0; i < numThreads; i++)
                thread[i].start();
        for (int i = 0; i < numThreads; i++) {
            thread[i].join();
       }
       
       } catch (Exception e) {
       	    e.printStackTrace(System.out);
      	    System.exit(0);
       }
       long stopTime = System.currentTimeMillis();
       double elapsed = (double)(stopTime - startTime) / 1000.0;
       long committed = Thread.totalCommitted;
       long total = Thread.totalTotal;
       long aborted = total - committed;
       if (total > 0) {
            System.out.printf("Committed: %d\nTotal: %d\nPercent committed: (%d%%)\n",
            committed,
            total,
          (100 * committed) / total);
       } else {
      	    System.out.println("No transactions executed!");
       }
       System.out.println("Elapsed time: " + elapsed + " seconds.");
       System.out.println("------------------------------------------");
    
    
    }
    private static void reportUsageErrorAndDie() {
        System.out.println("usage: dstm2.Main [-m <managerclass>] [-t <#threads>] [-a <adapter>]");
        System.exit(0); 
    }

}
