/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ParallelGrep;

import TransactionalIO.Utilities.Range;
import TransactionalIO.interfaces.IOOperations;
import TransactionalIO.core.MyDefaults;
import TransactionalIO.core.ExtendedTransaction;
import TransactionalIO.core.TransactionLocalFileAttributes;
import TransactionalIO.core.TransactionalFile;
import TransactionalIO.core.Wrapper;
import TransactionalIO.core.WriteOperations;
import TransactionalIO.exceptions.GracefulException;
import dstm2.SpecialTransactionalFile;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Iterator;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import dstm2.Thread;
import dstm2.atomic;
import dstm2.AtomicArray;
import dstm2.Defaults;
import dstm2.factory.Factory;


import java.io.RandomAccessFile;

import java.util.Vector;

import java.util.concurrent.Callable;

/**
 *
 * @author navid
 */
public class ParallelGrep implements Runnable {


    private Thread thread;
    int thresh; 
    int size;
    long threadoffset;

    ///////////////////ParallelGrep data structure//////////////////////////////
    static boolean inevitable = Defaults.INEVITABLE;
    static String basedir;
    static TransactionalFile counterfile;
    static SpecialTransactionalFile inevitablecounterfile;
    static Factory<CountKeeper> counterfactory = Thread.makeFactory(CountKeeper.class);
    private static CountKeeper word1_occurence;
    private static CountKeeper word2_occurence;
    private static CountKeeper word3_occurence;
    private static CountKeeper word4_occurence;
    private static CountKeeper word5_occurence;
    ///////////////////////////////////////////////////////////////////////

    public ParallelGrep() {
        thread = new Thread(this);
    }

    public static void initParallelGrep(String bdir){
        int count = 0;
        basedir = bdir;

	word1_occurence = counterfactory.create();
	word1_occurence.setOccurence(0);
              
        word2_occurence = counterfactory.create();
       	word2_occurence.setOccurence(0);
              
        word3_occurence = counterfactory.create();
        word3_occurence.setOccurence(0);
              
        word4_occurence = counterfactory.create();
        word4_occurence.setOccurence(0);
           
        word5_occurence = counterfactory.create();
        word5_occurence.setOccurence(0);

	if (inevitable){
		try {
		            inevitablecounterfile = new SpecialTransactionalFile(basedir+"output.text", "rw");
        	} catch (FileNotFoundException ex) {
		            Logger.getLogger(ParallelGrep.class.getName()).log(Level.SEVERE, null, ex);
            	}		   
	 } 
	    else 
		   counterfile = new TransactionalFile(basedir+"output.text", "rw");
	
    }




    public void start() {
        thread.start();
    }

    public void join() {
        try {
            thread.join();
        } catch (InterruptedException ex) {
            Logger.getLogger(ParallelGrep.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void run() {

        parralelGrepBenchmark();
    }

    public void parralelGrepBenchmark() {
        try {

	    final IOOperations f1;
	    if (!(inevitable)){
	            f1 = new TransactionalFile(basedir+"iliad.text", "rw");
	    }
	    else{
	            f1 = new SpecialTransactionalFile(basedir+"iliad.text", "rw");
	    }
            final long threadoffset;
            final long toseek;
	    final byte[] data = new byte[1000];
            //threadoffset = 52921;
            threadoffset = 50000;
            toseek = Integer.valueOf(Thread.currentThread().getName().substring(7)) * threadoffset;
	    for (int m=0; m<3000; m++){	
	    f1.seek(toseek);
	    for (int l=0; l<2; l++){
		    Thread.doIt (new Callable<Boolean>(){
				public Boolean call(){	
					try{
					   	for (int k=0; k<25; k++){	
					    		int end=0;
							int start = 0;
						        long offset = 0; 	
							int result = f1.read(data);
							if (result==-1)
								return false;
							while (end<data.length){
								start = end;
							while(!(Character.isLetter((char)data[end]))){
									start++;
									end++;
								}
								while(Character.isLetter((char)data[end])){
									
									end++;
								}
								int index_of_object = processInput(new String(data, start, end-start));
								if (index_of_object == -1)
									continue;

						               if (inevitable){
									String tmp = "\n\n Found word " + new String(data, start, end-start) + " At offset: " + offset +"\n\n";
                		                	                inevitablecounterfile.write(tmp.getBytes());
                			                                inevitablecounterfile.write(data, 0, end);
							       }
			                                       else{
									String tmp = "\n\n Found word " + new String(data, start, end-start) + " At offset: " + offset + "\n\n";
                			                                counterfile.write(tmp.getBytes());
                			                                counterfile.write(data, 0, end);
							       }
		                                       		switch(index_of_object){
	                		                            case 0:
                	                		                    word1_occurence.setOccurence(word1_occurence.getOccurence() + 1);
                        	                	    		    break;
			                                            case 1:
                			                                    word2_occurence.setOccurence(word2_occurence.getOccurence() + 1);
                                           		                    break;
			                                            case 2:
        	                 		                                 word3_occurence.setOccurence(word3_occurence.getOccurence() + 1);
                                				                 break;
		                        	                    case 3:
                		                                 		word4_occurence.setOccurence(word4_occurence.getOccurence() + 1);
                                		                 		break;
		                	                            case 4:
		                		                                 word5_occurence.setOccurence(word5_occurence.getOccurence() + 1);
                		                		                 break;
							    	}
							}
						}
	        			} catch (IOException ex) {
					         Logger.getLogger(ParallelGrep.class.getName()).log(Level.SEVERE, null, ex);
					}
					finally {
						return true;
					}
				 }
			});
		}
		}

        } catch (IOException ex) {
            Logger.getLogger(ParallelGrep.class.getName()).log(Level.SEVERE, null, ex);
        }

    }


    static Integer  processInput(String str) {
            if (str.equalsIgnoreCase("Polydamas")) {
                return 0;
            }
            else if (str.equalsIgnoreCase("Cebriones")) {
                return 1;
            }
            else if (str.equalsIgnoreCase("Eurybates")) {
                return 2;
            }
            else if (str.equalsIgnoreCase("Menoetius")) {
                return 3;
            }
            else if (str.equalsIgnoreCase("countless")) {
                return 4;
            }
       return -1;
    }


    @atomic
    public interface CountKeeper{
        int getOccurence();
        void setOccurence(int value);;
    }
}

