/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ParallelSort;

import TransactionalIO.Utilities.Range;
import TransactionalIO.interfaces.IOOperations;
import TransactionalIO.core.MyDefaults;
import TransactionalIO.core.ExtendedTransaction;
import TransactionalIO.core.TransactionLocalFileAttributes;
import TransactionalIO.core.TransactionalFile;
import TransactionalIO.core.Wrapper;
import TransactionalIO.core.WriteOperations;
import TransactionalIO.exceptions.GracefulException;
import dstm2.SpecialTransactionalFile;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Iterator;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import dstm2.Thread;
import dstm2.atomic;
import dstm2.AtomicArray;
import dstm2.Defaults;
import dstm2.factory.Factory;


import java.io.RandomAccessFile;

import java.util.Vector;

import java.util.concurrent.Callable;

/**
 *
 * @author navid
 */
public class ParallelSort implements Runnable {


    private Thread thread;
    int thresh; 
    static boolean inevitable = Defaults.INEVITABLE;
    int size;
    long threadoffset;
    static String basedir;
    ///////////////////PureIO data structure//////////////////////
    
    static TransactionalFile[] pureiofiles;
    static SpecialTransactionalFile[] inevitablepureiofiles;

    ///////////////////////////////////////////////////////////////////////

    public ParallelSort() {
        thread = new Thread(this);
    }

    public static void initParallelSort(String bdir){
	try{
		basedir = bdir;
		if (inevitable){
			inevitablepureiofiles = new SpecialTransactionalFile[26];
			for (int i=0; i<26; i++){
				int j= i+ 'a';
				inevitablepureiofiles[i] = new SpecialTransactionalFile(basedir+String.valueOf((char) (97+i))+ ".text","rw");
			}
		}
		else{
			pureiofiles = new TransactionalFile[26];
			for (int i=0; i<26; i++){
				int j= i+ 'a';
				pureiofiles[i] = new TransactionalFile(basedir+String.valueOf((char) (97+i))+ ".text","rw");
			}	
		}
       
	}catch(IOException ex){	
		ex.printStackTrace();
	}
    }

    public void start() {
        thread.start();
    }

    public void join() {
        try {
            thread.join();
        } catch (InterruptedException ex) {
            Logger.getLogger(ParallelSort.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void run() {

            parallelSortBenchmark();
    }

    public void parallelSortBenchmark() {
        try {
            RandomAccessFile f1;
	    f1 = new RandomAccessFile(basedir+"randomwords.text", "rw");
            long toseek;
            long threadoffset;
            threadoffset = 51121;
            toseek =
                    (Integer.valueOf(Thread.currentThread().getName().substring(7))) * threadoffset;

            for (int i=0; i<10; i++){
	            f1.seek(toseek);
        	    if (toseek != 0) {
                	//////////////// skipt the first word since its been read already
		        f1.readLine();
        	    }
	           while (f1.getFilePointer() < toseek + threadoffset) {
        	        final String pureiodata = f1.readLine();
                	if (pureiodata == null) {
	                    break;
        	        }
                	boolean resultt = Thread.doIt(new Callable<Boolean>() {

	                    public Boolean call() {
				pureioexecute(pureiodata);
                	        return true;
	                    }
        	        });

	            }
	   }
        }catch (IOException ex) {
        	    Logger.getLogger(ParallelSort.class.getName()).log(Level.SEVERE, null, ex);
	}

    }


    public void pureioexecute(String str){
	try{
	
		int i = str.toLowerCase().charAt(0) - 'a';
		if (inevitable)
			inevitablepureiofiles[i].write(str.getBytes());
		else
			pureiofiles[i].write(str.getBytes());

	}catch(IOException e){
		e.printStackTrace();
	}
    }
}

