/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package microbms.readswithdelays;

import TransactionalIO.Utilities.Range;
import TransactionalIO.interfaces.IOOperations;
import TransactionalIO.core.MyDefaults;
import TransactionalIO.core.ExtendedTransaction;
import TransactionalIO.core.TransactionLocalFileAttributes;
import TransactionalIO.core.TransactionalFile;
import TransactionalIO.core.Wrapper;
import TransactionalIO.core.WriteOperations;
import TransactionalIO.exceptions.GracefulException;
import dstm2.SpecialTransactionalFile;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Iterator;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import dstm2.Thread;
import dstm2.atomic;
import dstm2.AtomicArray;
import dstm2.Defaults;
import dstm2.factory.Factory;


import java.io.RandomAccessFile;

import java.util.Vector;

import java.util.concurrent.Callable;

/**
 *
 * @author navid
 */
public class BM implements Runnable {


    private Thread thread;
    private String benchmark;
    public static Object lock = new Object();
    ///////////////////////////////////////////////////////////////////////

    public BM(String benchmark) {
        
        this.benchmark = benchmark;
        thread = new Thread(this);
   }
   


    public int dummy(int j){
        int result = 0 ;
	for (int i=0; i<10000;i++){
		result+=i*i;
		for (int k=0; k<10;k++){
			result+=k*i+j;
		}
	}
	return result;
    }
   
    public int lock(RandomAccessFile g, byte[] res){

					try{
						g.read(res);	
						int dum = 0;
						for(int j=0;j<5;j++){
							dum += dummy(dum+j); 
						}
						g.read(res);	
						return dum;
					}catch(IOException e){
						e.printStackTrace();
						return -1;
					}

    }
    
    public int lock(IOOperations g, byte[] res){

					try{
						g.read(res);	
						int dum = 0;
						for(int j=0;j<5;j++){
							dum += dummy(dum+j); 
						}
						g.read(res);	
						return dum;
					}catch(IOException e){
						e.printStackTrace();
						return -1;
					}
    }
    
    public void GlobalLockTest(){
        byte[] res = new byte[1023];
	for (int l=0; l<1023;l++)
		res[l]=(byte)'a';
	try{
		RandomAccessFile g = new RandomAccessFile("/scratch/TransactionalIO/test","rw"); 
        	long toseek = (Integer.valueOf(Thread.currentThread().getName().substring(7))) *4000;
		for (int i=0; i<2000;i++){
			g.seek(toseek);
			synchronized(lock){
				int resu = lock(g, res);
			}	
		}
	}catch(IOException e){
		e.printStackTrace();
	}
    }

    public void NonTest(){
         final byte[] res = new byte[1023];
	for (int l=0; l<1023;l++)
		res[l]=(byte)'a';
	try{
		final RandomAccessFile g = new RandomAccessFile("/scratch/TransactionalIO/test","rw"); 
        	long toseek = (Integer.valueOf(Thread.currentThread().getName().substring(7))) *4000;
		for (int i=0; i<2000;i++){
			g.seek(toseek);
			int resu = lock(g, res);
		}
	}catch(IOException e){
		e.printStackTrace();
	}
    }

    public void InevitableTest(){
        final byte[] res = new byte[1023];
	for (int l=0; l<1023;l++)
		res[l]=(byte)'a';
	try{
		final SpecialTransactionalFile in = new SpecialTransactionalFile("/scratch/TransactionalIO/test","rw"); 
	        final long toseek = (Integer.valueOf(Thread.currentThread().getName().substring(7))) *4000;

		for (int i=0; i<2000;i++){
			in.seek(toseek);
			Thread.doIt(new Callable<Boolean>(){
				public Boolean call(){
					int resu = lock(in, res);
					return true;
				}
			});
		}
	}catch(IOException e){
		e.printStackTrace();
	}
    }
    
    public void TransactionalTest(){
        final byte[] res = new byte[1023];
	for (int l=0; l<1023;l++)
		res[l]=(byte)'a';
	final TransactionalFile in = new TransactionalFile("/scratch/TransactionalIO/test","rw"); 
        final long toseek = (Integer.valueOf(Thread.currentThread().getName().substring(7))) *4000;
	try{
		for (int i=0; i<2000;i++){
			in.seek(toseek);
			Thread.doIt(new Callable<Boolean>(){
				public Boolean call(){
					int resu = lock(in, res);
					return true;
				}
			});
		}
	}catch(IOException e){
		e.printStackTrace();
	}
    }


    public void start() {
        thread.start();
    }

    public void join() {
        try {
            thread.join();
        } catch (InterruptedException ex) {
            Logger.getLogger(BM.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void run() {

        if (benchmark.equals("GlobalLockTest")) {
            GlobalLockTest();
	}
        else if (benchmark.equals("NonTest")) {
            NonTest();
	}
        else if (benchmark.equals("InevitableTest")) {
            InevitableTest();
	}
        else if (benchmark.equals("TransactionalTest")) {
            TransactionalTest();
	}
	else
		System.out.println("No Such Benchmark");
    }
}
