package tuplesoup.core;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author navid
 */

import TransactionalIO.interfaces.IOOperations;
import dstm2.Thread;
import dstm2.factory.Factory;
import java.io.*;



public class TableIndexEntryImplementation implements Comparable<TableIndexEntry>{
   TableIndexEntry entry;
   Factory<TableIndexEntry> factory = Thread.makeFactory(TableIndexEntry.class);


   public TableIndexEntryImplementation(String id,int rowsize,int location,long position){
        entry = factory.create();
        entry.setId(id);
        entry.setLocation(location);
        entry.setPosition(Long.valueOf(position));
        entry.setRowSize(rowsize);
        entry.setSize(-1);
    }
   
    public String getId(){
        return entry.getId();
    }
    
    public long getPosition(){
        return entry.getPosition();
    }
    
    public int getLocation(){
        return entry.getLocation();
    }
    
    public int getRowSize(){
        return entry.getRowSize();
    }
    
    public int compareTo(TableIndexEntry obj) throws ClassCastException{
        TableIndexEntry ent=(TableIndexEntry)obj;
        if(entry.getPosition()<ent.getPosition())return -1;
        if(entry.getPosition()==ent.getPosition())return 0;
        return 1;
    }
    
    public boolean equals(Object obj){
        try{
            TableIndexEntry ent=(TableIndexEntry)obj;
            if(ent.getLocation()==entry.getLocation()){
                if(ent.getPosition()==entry.getPosition()){
                    if(ent.getId().equals(entry.getId())){
                        return true;
                    }
                }
            }
        }catch(ClassCastException e){}
        return false;
    }
    
    public int getSize(){
        if(entry.getSize()<0)calcSize();
        return entry.getSize();
    }
    public void setSize(int size){
        entry.setSize(size);
    }
    private void calcSize(){
        try{
            ByteArrayOutputStream bout=new ByteArrayOutputStream();
            DataOutputStream dout=new DataOutputStream(bout);
            dout.writeInt(entry.getId().hashCode());
            dout.writeShort(entry.getId().length());
            dout.writeChars(entry.getId());
            dout.writeInt(entry.getRowSize());
            dout.writeByte(entry.getLocation());
            dout.writeLong(entry.getPosition());
            setSize(bout.size());
            dout.close();
            bout.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    protected void writeData(IOOperations out) throws IOException{
        long pre=out.getFilePointer();
        out.writeInt(entry.getId().hashCode());
        out.writeShort(entry.getId().length());
        out.writeChars(entry.getId());
        out.writeInt(entry.getRowSize());
        out.writeByte(entry.getLocation());
        out.writeLong(entry.getPosition());
        setSize((int)(out.getFilePointer()-pre));
    }
 
    protected void updateData(IOOperations out) throws IOException {
        long pre = out.getFilePointer();
        out.skipBytes(4+2+entry.getId().length()*2);
        out.writeInt(entry.getRowSize());
        out.writeByte(entry.getLocation());
        out.writeLong(entry.getPosition());
        setSize((int)(out.getFilePointer()-pre));
   }

   protected static TableIndexEntry readData(IOOperations in) throws IOException {
        long pre = in.getFilePointer();
        in.readInt();
        int num = in.readShort();
        StringBuilder buf = new StringBuilder(num);
        for (int i=0; i<num; i++){
                buf.append(in.readChar());
        }
        String id = buf.toString();
        int rowsize = in.readInt();
        int location = in.readByte();
        long position = in.readLong();
        TableIndexEntryImplementation tmp = new TableIndexEntryImplementation(id, rowsize, location, position);
        tmp.setSize((int)(in.getFilePointer()-pre));
        return tmp.entry;

   }

 
    

    protected static TableIndexEntry lookForData(String id, IOOperations in) throws IOException{
        int scanhash=id.hashCode();
        int datahash=in.readInt();
        int num=in.readShort();
        if(scanhash!=datahash){
            in.skipBytes(4+1+8+num*2);
            return null;
        }
        StringBuilder buf=new StringBuilder(num);
        for(int i=0;i<num;i++){
            char c = in.readChar();
            buf.append(c);
        }
        String readid=buf.toString();
        if(!readid.equals(id)){
            in.skipBytes(4+1+8);
            return null;
        }
        
        int rowsize=in.readInt();
        int location=in.readByte();
        long position=in.readLong();
        TableIndexEntryImplementation tmp=new TableIndexEntryImplementation(id,rowsize,location,position);
        return tmp.entry;
    }
}
